'From Objectworks for Smalltalk-80(tm), Version 2.5 of 29 July 1989 on 19 January 1990 at 1:14:25 pm'!

DelayedEvent subclass: #WaitingSimulationObject
	instanceVariableNames: 'amount resource '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Simulations'!


!WaitingSimulationObject methodsFor: 'task language'!

consume: aNumber
	amount _ (amount - aNumber) max: 0!

release
	resource produce: amount.
	amount _ 0!

release: anAmount
	resource produce: anAmount.
	amount _ amount - anAmount! !

!WaitingSimulationObject methodsFor: 'accessing'!

amount
	^amount!

name
	^resource name!

resource
	^resource!

resource: aResource
	resource _ aResource! !

!WaitingSimulationObject methodsFor: 'private'!

setAmount: aNumber resource: aResource
	amount _ aNumber.
	resource _ aResource! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

WaitingSimulationObject class
	instanceVariableNames: ''!


!WaitingSimulationObject class methodsFor: 'instance creation'!

for: amount of: aResource withPriority: aNumber
	^(self onCondition: aNumber) setAmount: amount resource: aResource!

for: amount withPriority: aNumber
	^(self onCondition: aNumber) setAmount: amount resource: nil! !